## MmGdbusSim

MmGdbusSim — Generated C code for the org.freedesktop.ModemManager1.Sim D-Bus interface

## Functions

gboolean | mm_gdbus_sim_get_active ()
const gchar * | mm_gdbus_sim_get_imsi ()
gchar * | mm_gdbus_sim_dup_imsi ()
const gchar * | mm_gdbus_sim_get_eid ()
gchar * | mm_gdbus_sim_dup_eid ()
const gchar * | mm_gdbus_sim_get_sim_identifier ()
gchar * | mm_gdbus_sim_dup_sim_identifier ()
const gchar * | mm_gdbus_sim_get_operator_identifier ()
gchar * | mm_gdbus_sim_dup_operator_identifier ()
const gchar * | mm_gdbus_sim_get_operator_name ()
gchar * | mm_gdbus_sim_dup_operator_name ()
const gchar *const * | mm_gdbus_sim_get_emergency_numbers ()
gchar ** | mm_gdbus_sim_dup_emergency_numbers ()
GVariant * | mm_gdbus_sim_dup_preferred_networks ()
GVariant * | mm_gdbus_sim_get_preferred_networks ()
GVariant * | mm_gdbus_sim_dup_gid1 ()
GVariant * | mm_gdbus_sim_get_gid1 ()
GVariant * | mm_gdbus_sim_dup_gid2 ()
GVariant * | mm_gdbus_sim_get_gid2 ()
guint | mm_gdbus_sim_get_sim_type ()
guint | mm_gdbus_sim_get_esim_status ()
guint | mm_gdbus_sim_get_removability ()
void | mm_gdbus_sim_call_send_pin ()
gboolean | mm_gdbus_sim_call_send_pin_finish ()
gboolean | mm_gdbus_sim_call_send_pin_sync ()
void | mm_gdbus_sim_call_send_puk ()
gboolean | mm_gdbus_sim_call_send_puk_finish ()
gboolean | mm_gdbus_sim_call_send_puk_sync ()
void | mm_gdbus_sim_call_enable_pin ()
gboolean | mm_gdbus_sim_call_enable_pin_finish ()
gboolean | mm_gdbus_sim_call_enable_pin_sync ()
void | mm_gdbus_sim_call_change_pin ()
gboolean | mm_gdbus_sim_call_change_pin_finish ()
gboolean | mm_gdbus_sim_call_change_pin_sync ()
void | mm_gdbus_sim_call_set_preferred_networks ()
gboolean | mm_gdbus_sim_call_set_preferred_networks_finish ()
gboolean | mm_gdbus_sim_call_set_preferred_networks_sync ()

## Properties

gboolean | active | Read / Write
char * | eid | Read / Write
GStrv | emergency-numbers | Read / Write
guint | esim-status | Read / Write
GVariant * | gid1 | Read / Write
GVariant * | gid2 | Read / Write
char * | imsi | Read / Write
char * | operator-identifier | Read / Write
char * | operator-name | Read / Write
GVariant * | preferred-networks | Read / Write
guint | removability | Read / Write
char * | sim-identifier | Read / Write
guint | sim-type | Read / Write

## Signals

gboolean | handle-change-pin | Run Last
gboolean | handle-enable-pin | Run Last
gboolean | handle-send-pin | Run Last
gboolean | handle-send-puk | Run Last
gboolean | handle-set-preferred-networks | Run Last

## Types and Values

| MmGdbusSim
struct | MmGdbusSimIface

## Object Hierarchy

        GInterface
        ╰── MmGdbusSim

## Prerequisites

MmGdbusSim requires GObject.

## Known Implementations

MmGdbusSim is implemented by MMSim, MmGdbusSimProxy and MmGdbusSimSkeleton.

## Description

This section contains code for working with the org.freedesktop.ModemManager1.Sim D-Bus interface in C.

## Functions

### mm_gdbus_sim_get_active ()

    gboolean
    mm_gdbus_sim_get_active (MmGdbusSim *object);

Gets the value of the "Active" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value.

### mm_gdbus_sim_get_imsi ()

    const gchar *
    mm_gdbus_sim_get_imsi (MmGdbusSim *object);

Gets the value of the "Imsi" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_sim_dup_imsi()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_sim_dup_imsi ()

    gchar *
    mm_gdbus_sim_dup_imsi (MmGdbusSim *object);

Gets a copy of the "Imsi" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

### mm_gdbus_sim_get_eid ()

    const gchar *
    mm_gdbus_sim_get_eid (MmGdbusSim *object);

Gets the value of the "Eid" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_sim_dup_eid()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_sim_dup_eid ()

    gchar *
    mm_gdbus_sim_dup_eid (MmGdbusSim *object);

Gets a copy of the "Eid" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

### mm_gdbus_sim_get_sim_identifier ()

    const gchar *
    mm_gdbus_sim_get_sim_identifier (MmGdbusSim *object);

Gets the value of the "SimIdentifier" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_sim_dup_sim_identifier()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_sim_dup_sim_identifier ()

    gchar *
    mm_gdbus_sim_dup_sim_identifier (MmGdbusSim *object);

Gets a copy of the "SimIdentifier" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

### mm_gdbus_sim_get_operator_identifier ()

    const gchar *
    mm_gdbus_sim_get_operator_identifier (MmGdbusSim *object);

Gets the value of the "OperatorIdentifier" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_sim_dup_operator_identifier()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_sim_dup_operator_identifier ()

    gchar *
    mm_gdbus_sim_dup_operator_identifier (MmGdbusSim *object);

Gets a copy of the "OperatorIdentifier" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

### mm_gdbus_sim_get_operator_name ()

    const gchar *
    mm_gdbus_sim_get_operator_name (MmGdbusSim *object);

Gets the value of the "OperatorName" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_sim_dup_operator_name()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_sim_dup_operator_name ()

    gchar *
    mm_gdbus_sim_dup_operator_name (MmGdbusSim *object);

Gets a copy of the "OperatorName" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

### mm_gdbus_sim_get_emergency_numbers ()

    const gchar *const *
    mm_gdbus_sim_get_emergency_numbers (MmGdbusSim *object);

Gets the value of the "EmergencyNumbers" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_sim_dup_emergency_numbers()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_sim_dup_emergency_numbers ()

    gchar **
    mm_gdbus_sim_dup_emergency_numbers (MmGdbusSim *object);

Gets a copy of the "EmergencyNumbers" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_strfreev()`.

[transfer full][nullable]

### mm_gdbus_sim_dup_preferred_networks ()

    GVariant *
    mm_gdbus_sim_dup_preferred_networks (MmGdbusSim *object);

Gets a copy of the "PreferredNetworks" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

### mm_gdbus_sim_get_preferred_networks ()

    GVariant *
    mm_gdbus_sim_get_preferred_networks (MmGdbusSim *object);

Gets the value of the "PreferredNetworks" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_sim_dup_preferred_networks()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_sim_dup_gid1 ()

    GVariant *
    mm_gdbus_sim_dup_gid1 (MmGdbusSim *object);

Gets a copy of the "Gid1" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

### mm_gdbus_sim_get_gid1 ()

    GVariant *
    mm_gdbus_sim_get_gid1 (MmGdbusSim *object);

Gets the value of the "Gid1" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_sim_dup_gid1()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_sim_dup_gid2 ()

    GVariant *
    mm_gdbus_sim_dup_gid2 (MmGdbusSim *object);

Gets a copy of the "Gid2" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

### mm_gdbus_sim_get_gid2 ()

    GVariant *
    mm_gdbus_sim_get_gid2 (MmGdbusSim *object);

Gets the value of the "Gid2" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_sim_dup_gid2()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_sim_get_sim_type ()

    guint
    mm_gdbus_sim_get_sim_type (MmGdbusSim *object);

Gets the value of the "SimType" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value.

### mm_gdbus_sim_get_esim_status ()

    guint
    mm_gdbus_sim_get_esim_status (MmGdbusSim *object);

Gets the value of the "EsimStatus" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value.

### mm_gdbus_sim_get_removability ()

    guint
    mm_gdbus_sim_get_removability (MmGdbusSim *object);

Gets the value of the "Removability" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusSim. |

#### Returns

The property value.

### mm_gdbus_sim_call_send_pin ()

    void
    mm_gdbus_sim_call_send_pin (MmGdbusSim *proxy,
                                const gchar *arg_pin,
                                GCancellable *cancellable,
                                GAsyncReadyCallback callback,
                                gpointer user_data);

Asynchronously invokes the `SendPin()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_sim_call_send_pin_finish()` to get the result of the operation.

See `mm_gdbus_sim_call_send_pin_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusSimProxy. |
arg_pin | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_sim_call_send_pin_finish ()

    gboolean
    mm_gdbus_sim_call_send_pin_finish (MmGdbusSim *proxy,
                                       GAsyncResult *res,
                                       GError **error);

Finishes an operation started with `mm_gdbus_sim_call_send_pin()`.

#### Parameters

proxy | A MmGdbusSimProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_sim_call_send_pin()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_sim_call_send_pin_sync ()

    gboolean
    mm_gdbus_sim_call_send_pin_sync (MmGdbusSim *proxy,
                                     const gchar *arg_pin,
                                     GCancellable *cancellable,
                                     GError **error);

Synchronously invokes the `SendPin()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_sim_call_send_pin()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusSimProxy. |
arg_pin | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_sim_call_send_puk ()

    void
    mm_gdbus_sim_call_send_puk (MmGdbusSim *proxy,
                                const gchar *arg_puk,
                                const gchar *arg_pin,
                                GCancellable *cancellable,
                                GAsyncReadyCallback callback,
                                gpointer user_data);

Asynchronously invokes the `SendPuk()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_sim_call_send_puk_finish()` to get the result of the operation.

See `mm_gdbus_sim_call_send_puk_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusSimProxy. |
arg_puk | Argument to pass with the method invocation. |
arg_pin | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_sim_call_send_puk_finish ()

    gboolean
    mm_gdbus_sim_call_send_puk_finish (MmGdbusSim *proxy,
                                       GAsyncResult *res,
                                       GError **error);

Finishes an operation started with `mm_gdbus_sim_call_send_puk()`.

#### Parameters

proxy | A MmGdbusSimProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_sim_call_send_puk()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_sim_call_send_puk_sync ()

    gboolean
    mm_gdbus_sim_call_send_puk_sync (MmGdbusSim *proxy,
                                     const gchar *arg_puk,
                                     const gchar *arg_pin,
                                     GCancellable *cancellable,
                                     GError **error);

Synchronously invokes the `SendPuk()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_sim_call_send_puk()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusSimProxy. |
arg_puk | Argument to pass with the method invocation. |
arg_pin | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_sim_call_enable_pin ()

    void
    mm_gdbus_sim_call_enable_pin (MmGdbusSim *proxy,
                                  const gchar *arg_pin,
                                  gboolean arg_enabled,
                                  GCancellable *cancellable,
                                  GAsyncReadyCallback callback,
                                  gpointer user_data);

Asynchronously invokes the `EnablePin()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_sim_call_enable_pin_finish()` to get the result of the operation.

See `mm_gdbus_sim_call_enable_pin_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusSimProxy. |
arg_pin | Argument to pass with the method invocation. |
arg_enabled | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_sim_call_enable_pin_finish ()

    gboolean
    mm_gdbus_sim_call_enable_pin_finish (MmGdbusSim *proxy,
                                         GAsyncResult *res,
                                         GError **error);

Finishes an operation started with `mm_gdbus_sim_call_enable_pin()`.

#### Parameters

proxy | A MmGdbusSimProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_sim_call_enable_pin()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_sim_call_enable_pin_sync ()

    gboolean
    mm_gdbus_sim_call_enable_pin_sync (MmGdbusSim *proxy,
                                       const gchar *arg_pin,
                                       gboolean arg_enabled,
                                       GCancellable *cancellable,
                                       GError **error);

Synchronously invokes the `EnablePin()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_sim_call_enable_pin()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusSimProxy. |
arg_pin | Argument to pass with the method invocation. |
arg_enabled | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_sim_call_change_pin ()

    void
    mm_gdbus_sim_call_change_pin (MmGdbusSim *proxy,
                                  const gchar *arg_old_pin,
                                  const gchar *arg_new_pin,
                                  GCancellable *cancellable,
                                  GAsyncReadyCallback callback,
                                  gpointer user_data);

Asynchronously invokes the `ChangePin()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_sim_call_change_pin_finish()` to get the result of the operation.

See `mm_gdbus_sim_call_change_pin_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusSimProxy. |
arg_old_pin | Argument to pass with the method invocation. |
arg_new_pin | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_sim_call_change_pin_finish ()

    gboolean
    mm_gdbus_sim_call_change_pin_finish (MmGdbusSim *proxy,
                                         GAsyncResult *res,
                                         GError **error);

Finishes an operation started with `mm_gdbus_sim_call_change_pin()`.

#### Parameters

proxy | A MmGdbusSimProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_sim_call_change_pin()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_sim_call_change_pin_sync ()

    gboolean
    mm_gdbus_sim_call_change_pin_sync (MmGdbusSim *proxy,
                                       const gchar *arg_old_pin,
                                       const gchar *arg_new_pin,
                                       GCancellable *cancellable,
                                       GError **error);

Synchronously invokes the `ChangePin()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_sim_call_change_pin()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusSimProxy. |
arg_old_pin | Argument to pass with the method invocation. |
arg_new_pin | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_sim_call_set_preferred_networks ()

    void
    mm_gdbus_sim_call_set_preferred_networks
                                   (MmGdbusSim *proxy,
                                    GVariant *arg_preferred_networks,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `SetPreferredNetworks()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_sim_call_set_preferred_networks_finish()` to get the result of the operation.

See `mm_gdbus_sim_call_set_preferred_networks_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusSimProxy. |
arg_preferred_networks | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_sim_call_set_preferred_networks_finish ()

    gboolean
    mm_gdbus_sim_call_set_preferred_networks_finish
                                   (MmGdbusSim *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_sim_call_set_preferred_networks()`.

#### Parameters

proxy | A MmGdbusSimProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_sim_call_set_preferred_networks()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_sim_call_set_preferred_networks_sync ()

    gboolean
    mm_gdbus_sim_call_set_preferred_networks_sync
                                   (MmGdbusSim *proxy,
                                    GVariant *arg_preferred_networks,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `SetPreferredNetworks()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_sim_call_set_preferred_networks()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusSimProxy. |
arg_preferred_networks | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

## Types and Values

### MmGdbusSim

    typedef struct _MmGdbusSim MmGdbusSim;

Abstract interface type for the D-Bus interface org.freedesktop.ModemManager1.Sim.

### struct MmGdbusSimIface

    struct MmGdbusSimIface {
      GTypeInterface parent_iface;

      gboolean (*handle_change_pin) (
        MmGdbusSim *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_old_pin,
        const gchar *arg_new_pin);

      gboolean (*handle_enable_pin) (
        MmGdbusSim *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_pin,
        gboolean arg_enabled);

      gboolean (*handle_send_pin) (
        MmGdbusSim *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_pin);

      gboolean (*handle_send_puk) (
        MmGdbusSim *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_puk,
        const gchar *arg_pin);

      gboolean (*handle_set_preferred_networks) (
        MmGdbusSim *object,
        GDBusMethodInvocation *invocation,
        GVariant *arg_preferred_networks);

      gboolean  (*get_active) (MmGdbusSim *object);

      const gchar * (*get_eid) (MmGdbusSim *object);

      const gchar *const * (*get_emergency_numbers) (MmGdbusSim *object);

      guint  (*get_esim_status) (MmGdbusSim *object);

      GVariant * (*get_gid1) (MmGdbusSim *object);

      GVariant * (*get_gid2) (MmGdbusSim *object);

      const gchar * (*get_imsi) (MmGdbusSim *object);

      const gchar * (*get_operator_identifier) (MmGdbusSim *object);

      const gchar * (*get_operator_name) (MmGdbusSim *object);

      GVariant * (*get_preferred_networks) (MmGdbusSim *object);

      guint  (*get_removability) (MmGdbusSim *object);

      const gchar * (*get_sim_identifier) (MmGdbusSim *object);

      guint  (*get_sim_type) (MmGdbusSim *object);
    };

Virtual table for the D-Bus interface org.freedesktop.ModemManager1.Sim.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_change_pin` () | Handler for the “handle-change-pin” signal. |
`handle_enable_pin` () | Handler for the “handle-enable-pin” signal. |
`handle_send_pin` () | Handler for the “handle-send-pin” signal. |
`handle_send_puk` () | Handler for the “handle-send-puk” signal. |
`handle_set_preferred_networks` () | Handler for the “handle-set-preferred-networks” signal. |
`get_active` () | Getter for the “active” property. |
`get_eid` () | Getter for the “eid” property. |
`get_emergency_numbers` () | Getter for the “emergency-numbers” property. |
`get_esim_status` () | Getter for the “esim-status” property. |
`get_gid1` () | Getter for the “gid1” property. |
`get_gid2` () | Getter for the “gid2” property. |
`get_imsi` () | Getter for the “imsi” property. |
`get_operator_identifier` () | Getter for the “operator-identifier” property. |
`get_operator_name` () | Getter for the “operator-name” property. |
`get_preferred_networks` () | Getter for the “preferred-networks” property. |
`get_removability` () | Getter for the “removability” property. |
`get_sim_identifier` () | Getter for the “sim-identifier” property. |
`get_sim_type` () | Getter for the “sim-type” property. |

## Property Details

### The `“active”` property

      “active”                   gboolean

Represents the D-Bus property "Active".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Default value: FALSE

### The `“eid”` property

      “eid”                      char *

Represents the D-Bus property "Eid".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Default value: NULL

### The `“emergency-numbers”` property

      “emergency-numbers”        GStrv

Represents the D-Bus property "EmergencyNumbers".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

### The `“esim-status”` property

      “esim-status”              guint

Represents the D-Bus property "EsimStatus".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Default value: 0

### The `“gid1”` property

      “gid1”                     GVariant *

Represents the D-Bus property "Gid1".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Allowed values: GVariant<ay>

Default value: NULL

### The `“gid2”` property

      “gid2”                     GVariant *

Represents the D-Bus property "Gid2".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Allowed values: GVariant<ay>

Default value: NULL

### The `“imsi”` property

      “imsi”                     char *

Represents the D-Bus property "Imsi".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Default value: NULL

### The `“operator-identifier”` property

      “operator-identifier”      char *

Represents the D-Bus property "OperatorIdentifier".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Default value: NULL

### The `“operator-name”` property

      “operator-name”            char *

Represents the D-Bus property "OperatorName".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Default value: NULL

### The `“preferred-networks”` property

      “preferred-networks”       GVariant *

Represents the D-Bus property "PreferredNetworks".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Allowed values: GVariant<a(su)>

Default value: NULL

### The `“removability”` property

      “removability”             guint

Represents the D-Bus property "Removability".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Default value: 0

### The `“sim-identifier”` property

      “sim-identifier”           char *

Represents the D-Bus property "SimIdentifier".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Default value: NULL

### The `“sim-type”` property

      “sim-type”                 guint

Represents the D-Bus property "SimType".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusSim

Flags: Read / Write

Default value: 0

## Signal Details

### The `“handle-change-pin”` signal

    gboolean
    user_function (MmGdbusSim            *object,
                   GDBusMethodInvocation *invocation,
                   char                  *arg_old_pin,
                   char                  *arg_new_pin,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `ChangePin()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_sim_complete_change_pin()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusSim. |
invocation | A GDBusMethodInvocation. |
arg_old_pin | Argument passed by remote caller. |
arg_new_pin | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-enable-pin”` signal

    gboolean
    user_function (MmGdbusSim            *object,
                   GDBusMethodInvocation *invocation,
                   char                  *arg_pin,
                   gboolean               arg_enabled,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `EnablePin()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_sim_complete_enable_pin()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusSim. |
invocation | A GDBusMethodInvocation. |
arg_pin | Argument passed by remote caller. |
arg_enabled | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-send-pin”` signal

    gboolean
    user_function (MmGdbusSim            *object,
                   GDBusMethodInvocation *invocation,
                   char                  *arg_pin,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `SendPin()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_sim_complete_send_pin()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusSim. |
invocation | A GDBusMethodInvocation. |
arg_pin | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-send-puk”` signal

    gboolean
    user_function (MmGdbusSim            *object,
                   GDBusMethodInvocation *invocation,
                   char                  *arg_puk,
                   char                  *arg_pin,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `SendPuk()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_sim_complete_send_puk()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusSim. |
invocation | A GDBusMethodInvocation. |
arg_puk | Argument passed by remote caller. |
arg_pin | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-set-preferred-networks”` signal

    gboolean
    user_function (MmGdbusSim            *object,
                   GDBusMethodInvocation *invocation,
                   GVariant              *arg_preferred_networks,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `SetPreferredNetworks()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_sim_complete_set_preferred_networks()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusSim. |
invocation | A GDBusMethodInvocation. |
arg_preferred_networks | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last